def main():
  # Wczytujemy liczbę zadań.
  N = int(input())

  # Wczytujemy punktację zadań.
  V = list(map(int, input().split()))

  # Sortujemy liczbę punktów od największej do najmniejszej.
  V.sort(reverse=True)

  # Liczymy sumy prefiksowe.
  sumy = [V[0]]
  for i in range(1, N):
    sumy.append(sumy[-1] + V[i])

  # Wczytujemy liczbę zapytań
  # (potencjalnych progów punktowych).
  Q = int(input())

  # Dla każdego zapytania,
  for _ in range(Q):
    # wczytujemy jego wartość
    P = int(input())
    # i wykorzystujemy wyszukiwanie binarne.
    # Ustawiamy początek i koniec przedziału, w którym wyszukujemy,
    start, koniec = 0, N-1
    # a następnie póki przedział ten jest niepusty
    while start <= koniec:
      # wybieramy środkowy element z tego przedziału,
      srodek = (start+koniec)//2
      # i porównujemy jego wartość z naszym zapytaniem,
      # odpowiednio zmieniając jeden z końców przedziału.
      if sumy[srodek] < P: start = srodek+1
      else: koniec = srodek-1
    # Finalnie wypisujemy liczbę zadań, powiększoną o jeden
    # (otrzymujemy wskaźnik na tablicę zadań, numerowaną od 0).
    print(start+1)


main()
